(in-package "MORPHICL")

(defclass color ()
  ((r    :type float    :initarg :r     :accessor color-r)
   (g    :type float    :initarg :g     :accessor color-g)
   (b    :type float    :initarg :b     :accessor color-b)))

(defun colorp (object)
  (typep object 'color))

(defgeneric color-r ((color color)))
(defgeneric (setf color-r) (r (color color)))
(defgeneric color-g ((color color)))
(defgeneric (setf color-g) (g (color color)))
(defgeneric color-b ((color color)))
(defgeneric (setf color-b) (b (color color)))
(defgeneric color-rgb ((color color)))
(defgeneric* (setf color-rgb) (r g b (color color)))

(defun make-color (r g b)
  (make-instance 'color :r r :g g :b b))

(defun copy-color (color)
  (make-instance 'color :r (color-r color) :g (color-g color) :b (color-b color)))

(defmethod color-rgb ((color color))
  (values (color-r color)
          (color-g color)
          (color-b color)))

(defmethod* (setf color-rgb) (r g b (color color))
  (values (setf (color-r color) r)
          (setf (color-g color) g)
          (setf (color-b color) b)))

(defconstant +color-black+ (make-color 0.0 0.0 0.0))
(defconstant +color-white+ (make-color 1.0 1.0 1.0))
(defconstant +color-red+ (make-color 1.0 0.0 0.0))
(defconstant +color-green+ (make-color 0.0 1.0 0.0))
(defconstant +color-blue+ (make-color 0.0 0.0 1.0))

