(in-package "MORPHICL")

(defclass label-morph (morph)
  ((label                :type string   
                         :initarg :label         
                         :accessor label-morph-label)
   (horizontal-alignment :type keyword
                         :initarg :horizontal-alignment
                         :initform :center
                         :accessor label-morph-horizontal-alignment)
   (vertical-alignment   :type keyword
                         :initarg :vertical-alignment
                         :initform :center
                         :accessor label-morph-vertical-alignment)))

(defmethod morph-draw ((morph label-morph) (canvas canvas))
  (canvas-draw-text canvas
                    (label-morph-label morph)
                    (canvas-translate-point canvas
                      (make-point
                        (case (label-morph-horizontal-alignment morph)
                          (:left   0)
                          (:right  
                            (- (rectangle-width (canvas-transformation canvas))
                               (font-width (canvas-font canvas) 
                                           (label-morph-label morph))))
                          (:center 
                            (round (- (rectangle-width (canvas-transformation canvas))
                                      (font-width (canvas-font canvas)
                                                  (label-morph-label morph)))
                                   2)))
                        (case (label-morph-vertical-alignment morph)
                          (:top    0)
                          (:bottom 
                            (- (rectangle-height (canvas-transformation canvas))
                               (font-height (canvas-font canvas)
                                            (label-morph-label morph))))
                          (:center
                            (round (- (rectangle-height (canvas-transformation canvas))
                                      (font-height (canvas-font canvas)
                                                   (label-morph-label morph)))
                                   2)))))))

